/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.data.site;

import com.vividsolutions.jts.geom.MultiPolygon;
import fr.cenra.rhomeo.api.InternationalResource;
import fr.cenra.rhomeo.api.annotations.RefersTo;
import fr.cenra.rhomeo.api.data.Site;
import fr.cenra.rhomeo.core.RhomeoCore;
import fr.cenra.rhomeo.core.list.HumidZoneType;
import fr.cenra.rhomeo.core.list.OdonateZoneBio;
import fr.cenra.rhomeo.core.list.OrthoptereZoneBio;

import java.util.Collection;
import java.util.Collections;
import java.util.Objects;

/**
 * POJO representing a site. No intelligence in here.
 *
 * @author Cédric Briançon (Geomatys)
 */
public class SiteImpl implements Site, Cloneable, InternationalResource {

    private MultiPolygon geometry;
    private String countyCode;
    private String referent;
    private String organization;
    private String zoneType;
    private String odonateType;
    private String orthoptereType;
    private String name;
    private String remarks;

    private SiteImpl() {}

    public SiteImpl(MultiPolygon geometry) {
        this.geometry = geometry;
    }

    public SiteImpl(MultiPolygon geometry, String countyCode, String referent, String organization, String zoneType,
                    String odonateType, String orthoptereType, String name, String remarks) {
        this.geometry = geometry;
        this.countyCode = countyCode;
        this.referent = referent;
        this.organization = organization;
        this.zoneType = zoneType;
        this.odonateType = odonateType;
        this.orthoptereType = orthoptereType;
        this.name = name;
        this.remarks = remarks;
    }

    @Override
    public MultiPolygon getGeometry() {
        return geometry;
    }

    public void setGeometry(MultiPolygon geometry) {
        this.geometry = geometry;
    }

    @Override
    public String getCountyCode() {
        return countyCode;
    }

    public void setCountyCode(final String county) {
        this.countyCode = county;
    }

    @Override
    public String getReferent() {
        return referent;
    }

    public void setReferent(String referent) {
        this.referent = referent;
    }

    @Override
    public String getOrganization() {
        return organization;
    }

    public void setOrganization(String organization) {
        this.organization = organization;
    }

    @RefersTo(type = HumidZoneType.class, property = "code")
    @Override
    public String getZoneType() {
        return zoneType;
    }

    public void setZoneType(String zoneType) {
        this.zoneType = zoneType;
    }

    @RefersTo(type = OdonateZoneBio.class, property = "code")
    @Override
    public String getOdonateType() {
        return odonateType;
    }

    public void setOdonateType(String odonateType) {
        this.odonateType = odonateType;
    }

    @Override
    public SiteImpl clone() {
        final SiteImpl newSite = new SiteImpl(geometry);
        newSite.setCountyCode(countyCode);
        newSite.setName(name);
        newSite.setOdonateType(odonateType);
        newSite.setOrthoptereType(orthoptereType);
        newSite.setOrganization(organization);
        newSite.setReferent(referent);
        newSite.setRemarks(remarks);
        newSite.setZoneType(zoneType);

        return newSite;
    }

    @RefersTo(type= OrthoptereZoneBio.class, property = "code")
    @Override
    public String getOrthoptereType() {
        return orthoptereType;
    }

    public void setOrthoptereType(String orthoptereType) {
        this.orthoptereType = orthoptereType;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    @Override
    public Collection<String> getAlias() {
        return Collections.singleton(name);
    }

    @Override
    public String toString() {
        return name;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null)
            return false;
        if (getClass() != o.getClass())
            return false;
        final SiteImpl other = (SiteImpl) o;

        return Objects.equals(this.geometry, other.geometry) &&
                RhomeoCore.equivalent(this.countyCode, other.countyCode) &&
                RhomeoCore.equivalent(this.referent, other.referent) &&
                RhomeoCore.equivalent(this.organization, other.organization) &&
                RhomeoCore.equivalent(this.zoneType, other.zoneType) &&
                RhomeoCore.equivalent(this.odonateType, other.odonateType) &&
                RhomeoCore.equivalent(this.orthoptereType, other.orthoptereType) &&
                RhomeoCore.equivalent(this.name, other.name) &&
                RhomeoCore.equivalent(this.remarks, other.remarks);
    }

    @Override
    public int hashCode() {
        int result = geometry.hashCode();
        result = 31 * result + name.hashCode();
        return result;
    }

    @Override
    public int compareTo(Site o) {
        return o == null ? -1 : getName().compareTo(o.getName());
    }
}
